#ifndef LBB_DEVICE_H
#define LBB_DEVICE_H
struct lbb_device;
struct block_device;
struct kobject;
struct gendisk;
#define STATE_INFO_INIT (0)
#define STATE_INFO_START (1)
#define STATE_INFO_STOP (2)
int lbb_register(int max_disk);
int lbb_unregister(void);
int lbb_create_disk(char * snap_shot_name,char * dev_orig,sector_t sect_beg,sector_t sect_end);
int lbb_delete_disk(struct lbb_device * xdev);
int lbb_check_disk(struct lbb_device * xdev);
int lbb_start_disk(struct lbb_device * xdev,char * save_path,sector_t parm1,sector_t parm2);
int lbb_reset_disk(struct lbb_device * xdev);
struct lbb_device * lbb_find_table(struct block_device * bdev);
struct lbb_device * lbb_find_by_remap_dev(struct gendisk * rm_disk);
struct lbb_device * lbb_kobj_find_dev(struct kobject * kobj);
struct lbb_device * lbb_find_by_name(char * dev_name);
struct lbb_device * lbb_find_by_orig(char * orig_name);
struct lbb_device * lbb_find_by_save(char * save_name);
const char * lbb_get_orig_name(struct lbb_device * xdev);
sector_t lbb_get_sect_beg(struct lbb_device * xdev);
sector_t lbb_get_sect_end(struct lbb_device * xdev);
sector_t lbb_get_rmp_dev(struct lbb_device * xdev);
void lbb_stop_catch(struct lbb_device * xdev,int info_code);
size_t lbb_blockmap_read(struct lbb_device * xdev,char * bitmap,size_t offset,size_t size);
int lbb_dev_get_status(struct lbb_device * xdev);
int lbb_bitmap_set_range(struct lbb_device * xdev,size_t offset,size_t size,char set);
int lbb_bitmap_check_range(struct lbb_device * xdev,size_t offset,size_t size,char tst);
size_t lbb_bitmap_write(struct lbb_device * xdev,char * bitmap,size_t offset,size_t size);
size_t lbb_bitmap_read(struct lbb_device * xdev,char * bitmap,size_t offset,size_t size);
size_t lbb_table_get_size(struct lbb_device * xdev);
size_t lbb_table_read(struct lbb_device * xdev,char * table,size_t offset,size_t size);
unsigned int lbb_xbitmap_print_info(struct lbb_device * xdev,char * buf);
unsigned int lbb_xstore_print_info(struct lbb_device * xdev,char * buf);
unsigned int lbb_xstore_cmd_info(struct lbb_device * xdev,char * buf);
size_t lbb_abstract_write(struct lbb_device * xdev,char * data,size_t size);
size_t lbb_abstract_read(struct lbb_device * xdev,char * data,size_t size);
unsigned int get_debug_info(char * buf);
size_t lbb_get_mem_used(void);
#endif
